
#include <Keypad.h>
#include "ventil.h"
// include the library code:
#include <LiquidCrystal.h>

/*
LCD RS pin to D40
LCD Enable to D42
LCD D4 to D46
LCD D5 to D48
LCD D6 to D50
LCD D7 to D52
CD R/W pin to ground
10K resistor:
ends to +5V and ground
wiper to LCD VO pin (pin 3)
*/

//stage Setup
int stage = 0;    //stage des Eingabeablaufs
int substage = 0; //Substage, genutzt in Stage 1
int input = 0;  //value of input in 10%
int booststage=0; //stage for boost; used in stage 2
int boost=0;  //weather or not the drink will be boosted
int val[6];       //Array um Eingegebene Mengen zu speichern
int t =7943;  //dealy to let 35ml of liquid trough the valve
int ges_m =0;
int s;  //0=groß; 1=normal; 2=shot
int sg;


//Keypad Setup+

const byte ROWS = 4; /* four rows */
const byte COLS = 4; /* four columns */
/* define the symbols on the buttons of the keypads */
char hexaKeys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};
byte rowPins[ROWS] = {24, 26, 28, 30}; /* connect to the row pinouts of the keypad */
byte colPins[COLS] = {32, 34, 36, 38}; /* connect to the column pinouts of the keypad */

/* initialize an instance of class NewKeypad */
Keypad customKeypad = Keypad( makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS); 

//Ventil Setup
ventil v0 = ventil(33);
ventil v1 = ventil(35);
ventil v2 = ventil(37);
ventil v3 = ventil(39);
ventil v4 = ventil(41);
ventil v5 = ventil(43);

//Bildschirm setup
const int rs = 40, en = 42, d4 = 46, d5 = 48, d6 = 50, d7 = 52;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);


void setup() {
  Serial.begin(9600);           // start serial for output
    for (int i=0; i<7; i++){
    val[i]=0;
    }
    // set up the LCD's number of columns and rows:
  lcd.begin(16, 2);
  // Print a message to the LCD.
  stage0();
}

void loop() {
   char customKey = customKeypad.getKey();

  if (customKey){
  Serial.println(customKey);
  event(customKey);
  }
}

void(* resetFunc) (void) = 0;//declare reset function at address 0

void stage0(){
  lcd.clear();
  lcd.setCursor(3,0);
  lcd.print("# -> start");
  lcd.setCursor(5,1);
  lcd.print("blyat");
  
  }

void stageW(){
  lcd.clear();
  lcd.setCursor(3,0);
  lcd.print("Normal:A");
  lcd.setCursor(0,1);
  lcd.print("Shot:C  Gross:B");
  }

void stageS(){
  lcd.clear();
  lcd.setCursor(1,0);
  lcd.print("GetreankNr des");
  lcd.setCursor(4,1);
  lcd.print("Shots:");
  }

//screen stup for stage 1
void stage1(){
  lcd.clear();
  lcd.setCursor(0,0);  
  lcd.print("Menge: 0");
  lcd.print("0% G:00%");
  lcd.setCursor(13,0);
  lcd.print(ges_m);
  lcd.setCursor(0,1);
  lcd.print("Getreank: ");
  lcd.print(substage+1);
  }

//screen setup fpr stage 2
void stage2(){
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Bitte Boostcode");
  lcd.setCursor(4,1);
  lcd.print("# -> skip");
  }

//screen for stage3
void stage3(){
  lcd.clear();
  if(val[5]==1){
    lcd.setCursor(0,0);
    lcd.print("Booooooooooooost");
    lcd.setCursor(2,1);
    lcd.print("Wird gemixt");
    }else{
      lcd.setCursor(2,0);
      lcd.print("Wird gemixt");
      }
  if(s==2){
    mix();
    }else{
    mix();
    }
   cancel();
  }

//advance Substage in Stage1
void advanceSubstage(){
  if(s==2){
    if(input>0 && input<6){
      val[input-1]=1;
      stage=3;
      stage3();
      }
    }else{

   
  if ((ges_m+input)>10){
      lcd.clear();
      lcd.setCursor(1,0); 
      lcd.print("mehr als 100%");
      lcd.setCursor(2,1);
      lcd.print("geht nicht!");
      delay(500);
      stage1();
    }else{ 

      val[substage]=input;   //input an passende Stelle in val Array
      ges_m = ges_m+input;   //merkt sich gesamt menge;
      
      if(ges_m==10){
        Serial.println("ges_m");
       stage=2;         //stage advance
       substage=0;
       stage2();
      }else
      if (substage<4){      //substage wird geprüft;
        substage++;         //substage erhöhen
        input=0;
        stage1();
 
      }else{
        stage=2;         //stage advance
        substage=0;
        stage2();
      } 
    }    
  }
}

//resets everything
void cancel(){
  resetFunc();
  }

void mix(){
  if(s==0){
    t=7943;
    }
  if(s==1){
    t=5513;
    }
  if(s==2){
    t=4413;
    }
  bool cont=true;
  bool vb0,vb1,vb2,vb3,vb4, vb5;
  unsigned long open_t=millis();
Serial.print(val[0]);
Serial.print(val[1]);
Serial.print(val[2]);
Serial.print(val[3]);
Serial.println(val[4]);
  
  //val[4]=0;
  v0.auf(val[0],t);
  v1.auf(val[1],t);
  v2.auf(val[2],t);
  v3.auf(val[3],t);
  v4.auf(val[4],t);
  v5.auf(val[5],4413);
  Serial.println(cont);
  while(cont){
    cont =false;
    delay(10);
    vb0 = v0.zu(open_t);
    vb1 = v1.zu(open_t);
    vb2 = v2.zu(open_t);
    vb3 = v3.zu(open_t);
    vb4 = v4.zu(open_t);
    vb5 = v5.zu(open_t);
   
    if(vb0||vb1||vb2||vb3||vb4||vb5){
      cont=true;
      }
  }
}

void event(char x) {
  
 //Stage 0
  if (stage == 0){
    //# um in nächste Stage zu kommen
    if(x == '#') {
      substage = 1;
      stageW();
      }else if(substage == 1){
        if(x=='A'){
          stage=1;
          substage=0;
          stage1();
          s=1;
          }
        if(x=='B'){
          stage=1;
          substage=0;
          stage1();
          s=0;
          }
        if(x=='C'){
          stage=1;
          substage=0;
          stageS();
          s=2;
          }
      } 
    }else

  //Stage 1
  if (stage == 1) {
    if(x == '#'){
      advanceSubstage();
    //Serial.println(substage);
      }

    //input
    if(isDigit(x)){         //input anpassen
      input = (int)x - 48;
      if(s==2){
        lcd.setCursor(10,1);
        lcd.print(input);
        }else{
      lcd.setCursor(7,0);
      lcd.print(input);
      }
    }
    //cancel
    if (x == '*'){
       cancel();
      }
      
   }else

  //Stage 2
  if (stage == 2) {
    if (x == '*'){      //check for cancel
      cancel();
        
    }else if (x == '#'){  
      stage=3;
      stage3();
      }
    if (x == 'B'){              //boosting
      booststage++;  
    }else if(x == '0'){
      booststage++;
    }else if(x == '0'){
      booststage++;
    }else if(x == '5'){
      booststage++;
    }else if(x == '7'){
      stage=3;
      val[5]=1;
      stage3();
    }else{                      //no boost -> stage abvance without boost
      stage=3;
      stage3();
    }

  }
}
